# Do not modify this file by hand.
#
# It is automatically generated by src/api_wrappers/generateRAPIWrappers.py.
# (Run make api_wrappers to update it.)

##' analysisAddTags API wrapper
##'
##' This function makes an API call to the \code{/analysis-xxxx/addTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Workflows-and-Analyses#API-method\%3A-\%2Fanalysis-xxxx\%2FaddTags}
analysisAddTags <- function(objectID,
                            inputParams=emptyNamedList,
                            jsonifyData=TRUE,
                            alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' analysisDescribe API wrapper
##'
##' This function makes an API call to the \code{/analysis-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Workflows-and-Analyses#API-method\%3A-\%2Fanalysis-xxxx\%2Fdescribe}
analysisDescribe <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' analysisRemoveTags API wrapper
##'
##' This function makes an API call to the \code{/analysis-xxxx/removeTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Workflows-and-Analyses#API-method\%3A-\%2Fanalysis-xxxx\%2FremoveTags}
analysisRemoveTags <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' analysisSetProperties API wrapper
##'
##' This function makes an API call to the \code{/analysis-xxxx/setProperties} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Workflows-and-Analyses#API-method\%3A-\%2Fanalysis-xxxx\%2FsetProperties}
analysisSetProperties <- function(objectID,
                                  inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setProperties', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' analysisTerminate API wrapper
##'
##' This function makes an API call to the \code{/analysis-xxxx/terminate} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Workflows-and-Analyses#API-method\%3A-\%2Fanalysis-xxxx\%2Fterminate}
analysisTerminate <- function(objectID,
                              inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'terminate', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appAddAuthorizedUsers API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/addAuthorizedUsers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app-xxxx\%5B/yyyy\%5D/addAuthorizedUsers}
appAddAuthorizedUsers <- function(appNameOrID, alias=NULL,
                                  inputParams=emptyNamedList, jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'addAuthorizedUsers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appAddCategories API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/addCategories} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app-xxxx\%5B/yyyy\%5D/addCategories}
appAddCategories <- function(appNameOrID, alias=NULL,
                             inputParams=emptyNamedList, jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'addCategories', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appAddDevelopers API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/addDevelopers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app-xxxx\%5B/yyyy\%5D/addDevelopers}
appAddDevelopers <- function(appNameOrID, alias=NULL,
                             inputParams=emptyNamedList, jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'addDevelopers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appAddTags API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/addTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app-xxxx\%5B/yyyy\%5D/addTags}
appAddTags <- function(appNameOrID, alias=NULL,
                       inputParams=emptyNamedList, jsonifyData=TRUE,
                       alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'addTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appDelete API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/delete} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app-xxxx\%5B/yyyy\%5D/delete}
appDelete <- function(appNameOrID, alias=NULL,
                      inputParams=emptyNamedList, jsonifyData=TRUE,
                      alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'delete', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appDescribe API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app-xxxx\%5B/yyyy\%5D/describe}
appDescribe <- function(appNameOrID, alias=NULL,
                        inputParams=emptyNamedList, jsonifyData=TRUE,
                        alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appGet API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/get} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app-xxxx\%5B/yyyy\%5D/get}
appGet <- function(appNameOrID, alias=NULL,
                   inputParams=emptyNamedList, jsonifyData=TRUE,
                   alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'get', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appInstall API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/install} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app-xxxx\%5B/yyyy\%5D/install}
appInstall <- function(appNameOrID, alias=NULL,
                       inputParams=emptyNamedList, jsonifyData=TRUE,
                       alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'install', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appListAuthorizedUsers API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/listAuthorizedUsers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app-xxxx\%5B/yyyy\%5D/listAuthorizedUsers}
appListAuthorizedUsers <- function(appNameOrID, alias=NULL,
                                   inputParams=emptyNamedList, jsonifyData=TRUE,
                                   alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'listAuthorizedUsers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appListCategories API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/listCategories} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app-xxxx\%5B/yyyy\%5D/listCategories}
appListCategories <- function(appNameOrID, alias=NULL,
                              inputParams=emptyNamedList, jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'listCategories', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appListDevelopers API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/listDevelopers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app-xxxx\%5B/yyyy\%5D/listDevelopers}
appListDevelopers <- function(appNameOrID, alias=NULL,
                              inputParams=emptyNamedList, jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'listDevelopers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appPublish API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/publish} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app-xxxx\%5B/yyyy\%5D/publish}
appPublish <- function(appNameOrID, alias=NULL,
                       inputParams=emptyNamedList, jsonifyData=TRUE,
                       alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'publish', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appRemoveAuthorizedUsers API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/removeAuthorizedUsers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app-xxxx\%5B/yyyy\%5D/removeAuthorizedUsers}
appRemoveAuthorizedUsers <- function(appNameOrID, alias=NULL,
                                     inputParams=emptyNamedList, jsonifyData=TRUE,
                                     alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'removeAuthorizedUsers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appRemoveCategories API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/removeCategories} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app-xxxx\%5B/yyyy\%5D/removeCategories}
appRemoveCategories <- function(appNameOrID, alias=NULL,
                                inputParams=emptyNamedList, jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'removeCategories', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appRemoveDevelopers API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/removeDevelopers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app-xxxx\%5B/yyyy\%5D/removeDevelopers}
appRemoveDevelopers <- function(appNameOrID, alias=NULL,
                                inputParams=emptyNamedList, jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'removeDevelopers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appRemoveTags API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/removeTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app-xxxx\%5B/yyyy\%5D/removeTags}
appRemoveTags <- function(appNameOrID, alias=NULL,
                          inputParams=emptyNamedList, jsonifyData=TRUE,
                          alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'removeTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appRun API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/run} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app-xxxx\%5B/yyyy\%5D/run}
appRun <- function(appNameOrID, alias=NULL,
                   inputParams=emptyNamedList, jsonifyData=TRUE,
                   alwaysRetry=FALSE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'run', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appValidateBatch API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/validateBatch} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app-xxxx\%5B/yyyy\%5D/validateBatch}
appValidateBatch <- function(appNameOrID, alias=NULL,
                             inputParams=emptyNamedList, jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'validateBatch', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appUninstall API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/uninstall} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app-xxxx\%5B/yyyy\%5D/uninstall}
appUninstall <- function(appNameOrID, alias=NULL,
                         inputParams=emptyNamedList, jsonifyData=TRUE,
                         alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'uninstall', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appUpdate API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/update} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app-xxxx\%5B/yyyy\%5D/update}
appUpdate <- function(appNameOrID, alias=NULL,
                      inputParams=emptyNamedList, jsonifyData=TRUE,
                      alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'update', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appNew API wrapper
##'
##' This function makes an API call to the \code{/app/new} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Apps#API-method:-/app/new}
appNew <- function(inputParams=emptyNamedList,
                   jsonifyData=TRUE,
                   alwaysRetry=FALSE) {
  dxHTTPRequest('/app/new', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' appletAddTags API wrapper
##'
##' This function makes an API call to the \code{/applet-xxxx/addTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Tags#API-method\%3A-\%2Fclass-xxxx\%2FaddTags}
appletAddTags <- function(objectID,
                          inputParams=emptyNamedList,
                          jsonifyData=TRUE,
                          alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appletDescribe API wrapper
##'
##' This function makes an API call to the \code{/applet-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Applets-and-Entry-Points#API-method\%3A-\%2Fapplet-xxxx\%2Fdescribe}
appletDescribe <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appletGet API wrapper
##'
##' This function makes an API call to the \code{/applet-xxxx/get} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Applets-and-Entry-Points#API-method\%3A-\%2Fapplet-xxxx\%2Fget}
appletGet <- function(objectID,
                      inputParams=emptyNamedList,
                      jsonifyData=TRUE,
                      alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'get', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appletGetDetails API wrapper
##'
##' This function makes an API call to the \code{/applet-xxxx/getDetails} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Details-and-Links#API-method\%3A-\%2Fclass-xxxx\%2FgetDetails}
appletGetDetails <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'getDetails', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appletListProjects API wrapper
##'
##' This function makes an API call to the \code{/applet-xxxx/listProjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Cloning#API-method\%3A-\%2Fclass-xxxx\%2FlistProjects}
appletListProjects <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listProjects', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appletRemoveTags API wrapper
##'
##' This function makes an API call to the \code{/applet-xxxx/removeTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Tags#API-method\%3A-\%2Fclass-xxxx\%2FremoveTags}
appletRemoveTags <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appletRename API wrapper
##'
##' This function makes an API call to the \code{/applet-xxxx/rename} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Name#API-method\%3A-\%2Fclass-xxxx\%2Frename}
appletRename <- function(objectID,
                         inputParams=emptyNamedList,
                         jsonifyData=TRUE,
                         alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'rename', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appletValidateBatch API wrapper
##'
##' This function makes an API call to the \code{/applet-xxxx/validateBatch} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Applets-and-Entry-Points#API-method\%3A-\%2Fapplet-xxxx\%2FvalidateBatch}
appletValidateBatch <- function(objectID,
                                inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'validateBatch', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appletRun API wrapper
##'
##' This function makes an API call to the \code{/applet-xxxx/run} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Applets-and-Entry-Points#API-method\%3A-\%2Fapplet-xxxx\%2Frun}
appletRun <- function(objectID,
                      inputParams=emptyNamedList,
                      jsonifyData=TRUE,
                      alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'run', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appletSetProperties API wrapper
##'
##' This function makes an API call to the \code{/applet-xxxx/setProperties} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Properties#API-method\%3A-\%2Fclass-xxxx\%2FsetProperties}
appletSetProperties <- function(objectID,
                                inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setProperties', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appletNew API wrapper
##'
##' This function makes an API call to the \code{/applet/new} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Applets-and-Entry-Points#API-method\%3A-\%2Fapplet\%2Fnew}
appletNew <- function(inputParams=emptyNamedList,
                      jsonifyData=TRUE,
                      alwaysRetry=FALSE) {
  dxHTTPRequest('/applet/new', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' containerClone API wrapper
##'
##' This function makes an API call to the \code{/container-xxxx/clone} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Cloning#API-method\%3A-\%2Fclass-xxxx\%2Fclone}
containerClone <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'clone', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' containerDescribe API wrapper
##'
##' This function makes an API call to the \code{/container-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Containers-for-Execution#API-method\%3A-\%2Fcontainer-xxxx\%2Fdescribe}
containerDescribe <- function(objectID,
                              inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' containerDestroy API wrapper
##'
##' This function makes an API call to the \code{/container-xxxx/destroy} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
containerDestroy <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'destroy', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' containerListFolder API wrapper
##'
##' This function makes an API call to the \code{/container-xxxx/listFolder} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Folders-and-Deletion#API-method\%3A-\%2Fclass-xxxx\%2FlistFolder}
containerListFolder <- function(objectID,
                                inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listFolder', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' containerMove API wrapper
##'
##' This function makes an API call to the \code{/container-xxxx/move} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Folders-and-Deletion#API-method\%3A-\%2Fclass-xxxx\%2Fmove}
containerMove <- function(objectID,
                          inputParams=emptyNamedList,
                          jsonifyData=TRUE,
                          alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'move', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' containerNewFolder API wrapper
##'
##' This function makes an API call to the \code{/container-xxxx/newFolder} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Folders-and-Deletion#API-method\%3A-\%2Fclass-xxxx\%2FnewFolder}
containerNewFolder <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'newFolder', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' containerRemoveFolder API wrapper
##'
##' This function makes an API call to the \code{/container-xxxx/removeFolder} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Folders-and-Deletion#API-method\%3A-\%2Fclass-xxxx\%2FremoveFolder}
containerRemoveFolder <- function(objectID,
                                  inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'removeFolder', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' containerRemoveObjects API wrapper
##'
##' This function makes an API call to the \code{/container-xxxx/removeObjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Folders-and-Deletion#API-method\%3A-\%2Fclass-xxxx\%2FremoveObjects}
containerRemoveObjects <- function(objectID,
                                   inputParams=emptyNamedList,
                                   jsonifyData=TRUE,
                                   alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'removeObjects', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' containerRenameFolder API wrapper
##'
##' This function makes an API call to the \code{/container-xxxx/renameFolder} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Folders-and-Deletion#API-method\%3A-\%2Fclass-xxxx\%2FrenameFolder}
containerRenameFolder <- function(objectID,
                                  inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'renameFolder', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseAddTags API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/addTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Tags#API-method\%3A-\%2Fclass-xxxx\%2FaddTags}
databaseAddTags <- function(objectID,
                            inputParams=emptyNamedList,
                            jsonifyData=TRUE,
                            alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseAddTypes API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/addTypes} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Types#API-method\%3A-\%2Fclass-xxxx\%2FaddTypes}
databaseAddTypes <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTypes', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseClose API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/close} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Data-Object-Lifecycle#API-method\%3A-\%2Fclass-xxxx\%2Fclose}
databaseClose <- function(objectID,
                          inputParams=emptyNamedList,
                          jsonifyData=TRUE,
                          alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'close', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseDescribe API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Databases#API-method\%3A-\%2Fdatabase-xxxx\%2Fdescribe}
databaseDescribe <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseGetDetails API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/getDetails} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Details-and-Links#API-method\%3A-\%2Fclass-xxxx\%2FgetDetails}
databaseGetDetails <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'getDetails', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseListProjects API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/listProjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Cloning#API-method\%3A-\%2Fclass-xxxx\%2FlistProjects}
databaseListProjects <- function(objectID,
                                 inputParams=emptyNamedList,
                                 jsonifyData=TRUE,
                                 alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listProjects', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseRelocate API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/relocate} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Databases#API-method\%3A-\%2Fdatabase-xxxx\%2Frelocate}
databaseRelocate <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'relocate', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseRemoveTags API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/removeTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Tags#API-method\%3A-\%2Fclass-xxxx\%2FremoveTags}
databaseRemoveTags <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseRemoveTypes API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/removeTypes} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Types#API-method\%3A-\%2Fclass-xxxx\%2FremoveTypes}
databaseRemoveTypes <- function(objectID,
                                inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTypes', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseRename API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/rename} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Name#API-method\%3A-\%2Fclass-xxxx\%2Frename}
databaseRename <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'rename', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseSetDetails API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/setDetails} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Details-and-Links#API-method\%3A-\%2Fclass-xxxx\%2FsetDetails}
databaseSetDetails <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setDetails', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseSetProperties API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/setProperties} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Properties#API-method\%3A-\%2Fclass-xxxx\%2FsetProperties}
databaseSetProperties <- function(objectID,
                                  inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setProperties', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseSetVisibility API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/setVisibility} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Visibility#API-method\%3A-\%2Fclass-xxxx\%2FsetVisibility}
databaseSetVisibility <- function(objectID,
                                  inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setVisibility', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseListFolder API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/listFolder} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Databases#API-method\%3A-\%2Fdatabase-xxxx\%2FlistFolder}
databaseListFolder <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listFolder', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileAddTags API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/addTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Tags#API-method\%3A-\%2Fclass-xxxx\%2FaddTags}
fileAddTags <- function(objectID,
                        inputParams=emptyNamedList,
                        jsonifyData=TRUE,
                        alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileAddTypes API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/addTypes} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Types#API-method\%3A-\%2Fclass-xxxx\%2FaddTypes}
fileAddTypes <- function(objectID,
                         inputParams=emptyNamedList,
                         jsonifyData=TRUE,
                         alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTypes', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileClose API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/close} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Files#API-method\%3A-\%2Ffile-xxxx\%2Fclose}
fileClose <- function(objectID,
                      inputParams=emptyNamedList,
                      jsonifyData=TRUE,
                      alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'close', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileDescribe API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Files#API-method\%3A-\%2Ffile-xxxx\%2Fdescribe}
fileDescribe <- function(objectID,
                         inputParams=emptyNamedList,
                         jsonifyData=TRUE,
                         alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileDownload API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/download} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Files#API-method\%3A-\%2Ffile-xxxx\%2Fdownload}
fileDownload <- function(objectID,
                         inputParams=emptyNamedList,
                         jsonifyData=TRUE,
                         alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'download', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileGetDetails API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/getDetails} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Details-and-Links#API-method\%3A-\%2Fclass-xxxx\%2FgetDetails}
fileGetDetails <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'getDetails', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileListProjects API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/listProjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Cloning#API-method\%3A-\%2Fclass-xxxx\%2FlistProjects}
fileListProjects <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listProjects', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileRemoveTags API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/removeTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Tags#API-method\%3A-\%2Fclass-xxxx\%2FremoveTags}
fileRemoveTags <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileRemoveTypes API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/removeTypes} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Types#API-method\%3A-\%2Fclass-xxxx\%2FremoveTypes}
fileRemoveTypes <- function(objectID,
                            inputParams=emptyNamedList,
                            jsonifyData=TRUE,
                            alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTypes', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileRename API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/rename} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Name#API-method\%3A-\%2Fclass-xxxx\%2Frename}
fileRename <- function(objectID,
                       inputParams=emptyNamedList,
                       jsonifyData=TRUE,
                       alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'rename', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileSetDetails API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/setDetails} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Details-and-Links#API-method\%3A-\%2Fclass-xxxx\%2FsetDetails}
fileSetDetails <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setDetails', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileSetProperties API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/setProperties} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Properties#API-method\%3A-\%2Fclass-xxxx\%2FsetProperties}
fileSetProperties <- function(objectID,
                              inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setProperties', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileSetVisibility API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/setVisibility} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Visibility#API-method\%3A-\%2Fclass-xxxx\%2FsetVisibility}
fileSetVisibility <- function(objectID,
                              inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setVisibility', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileUpload API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/upload} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Files#API-method\%3A-\%2Ffile-xxxx\%2Fupload}
fileUpload <- function(objectID,
                       inputParams=emptyNamedList,
                       jsonifyData=TRUE,
                       alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'upload', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileNew API wrapper
##'
##' This function makes an API call to the \code{/file/new} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Files#API-method\%3A-\%2Ffile\%2Fnew}
fileNew <- function(inputParams=emptyNamedList,
                    jsonifyData=TRUE,
                    alwaysRetry=FALSE) {
  dxHTTPRequest('/file/new', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' globalWorkflowAddAuthorizedUsers API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/addAuthorizedUsers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Global-Workflows#API-method:-/globalworkflow-xxxx\%5B/yyyy\%5D/addAuthorizedUsers}
globalWorkflowAddAuthorizedUsers <- function(objectID,
                                             inputParams=emptyNamedList,
                                             jsonifyData=TRUE,
                                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addAuthorizedUsers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowAddCategories API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/addCategories} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Global-Workflows#API-method:-/globalworkflow-xxxx\%5B/yyyy\%5D/addCategories}
globalWorkflowAddCategories <- function(objectID,
                                        inputParams=emptyNamedList,
                                        jsonifyData=TRUE,
                                        alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addCategories', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowAddDevelopers API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/addDevelopers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Global-Workflows#API-method:-/globalworkflow-xxxx\%5B/yyyy\%5D/addDevelopers}
globalWorkflowAddDevelopers <- function(objectID,
                                        inputParams=emptyNamedList,
                                        jsonifyData=TRUE,
                                        alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addDevelopers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowAddTags API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/addTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Global-Workflows#API-method:-/globalworkflow-xxxx\%5B/yyyy\%5D/addTags}
globalWorkflowAddTags <- function(objectID,
                                  inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowDelete API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/delete} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Global-Workflows#API-method:-/globalworkflow-xxxx\%5B/yyyy\%5D/delete}
globalWorkflowDelete <- function(objectID,
                                 inputParams=emptyNamedList,
                                 jsonifyData=TRUE,
                                 alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'delete', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowDescribe API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Global-Workflows#API-method:-/globalworkflow-xxxx\%5B/yyyy\%5D/describe}
globalWorkflowDescribe <- function(objectID,
                                   inputParams=emptyNamedList,
                                   jsonifyData=TRUE,
                                   alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowListAuthorizedUsers API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/listAuthorizedUsers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Global-Workflows#API-method:-/globalworkflow-xxxx\%5B/yyyy\%5D/listAuthorizedUsers}
globalWorkflowListAuthorizedUsers <- function(objectID,
                                              inputParams=emptyNamedList,
                                              jsonifyData=TRUE,
                                              alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listAuthorizedUsers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowListCategories API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/listCategories} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Global-Workflows#API-method:-/globalworkflow-xxxx\%5B/yyyy\%5D/listCategories}
globalWorkflowListCategories <- function(objectID,
                                         inputParams=emptyNamedList,
                                         jsonifyData=TRUE,
                                         alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listCategories', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowListDevelopers API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/listDevelopers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Global-Workflows#API-method:-/globalworkflow-xxxx\%5B/yyyy\%5D/listDevelopers}
globalWorkflowListDevelopers <- function(objectID,
                                         inputParams=emptyNamedList,
                                         jsonifyData=TRUE,
                                         alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listDevelopers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowPublish API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/publish} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Global-Workflows#API-method:-/globalworkflow-xxxx\%5B/yyyy\%5D/publish}
globalWorkflowPublish <- function(objectID,
                                  inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'publish', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowRemoveAuthorizedUsers API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/removeAuthorizedUsers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Global-Workflows#API-method:-/globalworkflow-xxxx\%5B/yyyy\%5D/removeAuthorizedUsers}
globalWorkflowRemoveAuthorizedUsers <- function(objectID,
                                                inputParams=emptyNamedList,
                                                jsonifyData=TRUE,
                                                alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeAuthorizedUsers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowRemoveCategories API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/removeCategories} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Global-Workflows#API-method:-/globalworkflow-xxxx\%5B/yyyy\%5D/removeCategories}
globalWorkflowRemoveCategories <- function(objectID,
                                           inputParams=emptyNamedList,
                                           jsonifyData=TRUE,
                                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeCategories', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowRemoveDevelopers API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/removeDevelopers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Global-Workflows#API-method:-/globalworkflow-xxxx\%5B/yyyy\%5D/removeDevelopers}
globalWorkflowRemoveDevelopers <- function(objectID,
                                           inputParams=emptyNamedList,
                                           jsonifyData=TRUE,
                                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeDevelopers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowRemoveTags API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/removeTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Global-Workflows#API-method:-/globalworkflow-xxxx\%5B/yyyy\%5D/removeTags}
globalWorkflowRemoveTags <- function(objectID,
                                     inputParams=emptyNamedList,
                                     jsonifyData=TRUE,
                                     alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowRun API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/run} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Global-Workflows#API-method:-/globalworkflow-xxxx\%5B/yyyy\%5D/run}
globalWorkflowRun <- function(objectID,
                              inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'run', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowUpdate API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/update} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Global-Workflows#API-method:-/globalworkflow-xxxx\%5B/yyyy\%5D/update}
globalWorkflowUpdate <- function(objectID,
                                 inputParams=emptyNamedList,
                                 jsonifyData=TRUE,
                                 alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'update', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowNew API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow/new} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Global-Workflows#API-method:-/globalworkflow/new}
globalWorkflowNew <- function(inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=FALSE) {
  dxHTTPRequest('/globalworkflow/new', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' jobAddTags API wrapper
##'
##' This function makes an API call to the \code{/job-xxxx/addTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Applets-and-Entry-Points#API-method\%3A-\%2Fjob-xxxx\%2FaddTags}
jobAddTags <- function(objectID,
                       inputParams=emptyNamedList,
                       jsonifyData=TRUE,
                       alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' jobDescribe API wrapper
##'
##' This function makes an API call to the \code{/job-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Applets-and-Entry-Points#API-method\%3A-\%2Fjob-xxxx\%2Fdescribe}
jobDescribe <- function(objectID,
                        inputParams=emptyNamedList,
                        jsonifyData=TRUE,
                        alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' jobGetLog API wrapper
##'
##' This function makes an API call to the \code{/job-xxxx/getLog} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Applets-and-Entry-Points#API-method\%3A-\%2Fjob-xxxx\%2FgetLog}
jobGetLog <- function(objectID,
                      inputParams=emptyNamedList,
                      jsonifyData=TRUE,
                      alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'getLog', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' jobRemoveTags API wrapper
##'
##' This function makes an API call to the \code{/job-xxxx/removeTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Applets-and-Entry-Points#API-method\%3A-\%2Fjob-xxxx\%2FremoveTags}
jobRemoveTags <- function(objectID,
                          inputParams=emptyNamedList,
                          jsonifyData=TRUE,
                          alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' jobSetProperties API wrapper
##'
##' This function makes an API call to the \code{/job-xxxx/setProperties} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Applets-and-Entry-Points#API-method\%3A-\%2Fjob-xxxx\%2FsetProperties}
jobSetProperties <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setProperties', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' jobTerminate API wrapper
##'
##' This function makes an API call to the \code{/job-xxxx/terminate} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Applets-and-Entry-Points#API-method\%3A-\%2Fjob-xxxx\%2Fterminate}
jobTerminate <- function(objectID,
                         inputParams=emptyNamedList,
                         jsonifyData=TRUE,
                         alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'terminate', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' jobNew API wrapper
##'
##' This function makes an API call to the \code{/job/new} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Applets-and-Entry-Points#API-method\%3A-\%2Fjob\%2Fnew}
jobNew <- function(inputParams=emptyNamedList,
                   jsonifyData=TRUE,
                   alwaysRetry=FALSE) {
  dxHTTPRequest('/job/new', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' notificationsGet API wrapper
##'
##' This function makes an API call to the \code{/notifications/get} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
notificationsGet <- function(inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  dxHTTPRequest('/notifications/get', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' notificationsMarkRead API wrapper
##'
##' This function makes an API call to the \code{/notifications/markRead} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
notificationsMarkRead <- function(inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  dxHTTPRequest('/notifications/markRead', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' orgDescribe API wrapper
##'
##' This function makes an API call to the \code{/org-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Organizations#API-method\%3A-\%2Forg-xxxx\%2Fdescribe}
orgDescribe <- function(objectID,
                        inputParams=emptyNamedList,
                        jsonifyData=TRUE,
                        alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' orgFindMembers API wrapper
##'
##' This function makes an API call to the \code{/org-xxxx/findMembers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Organizations#API-method\%3A-\%2Forg-xxxx\%2FfindMembers}
orgFindMembers <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'findMembers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' orgFindProjects API wrapper
##'
##' This function makes an API call to the \code{/org-xxxx/findProjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Organizations#API-method\%3A-\%2Forg-xxxx\%2FfindProjects}
orgFindProjects <- function(objectID,
                            inputParams=emptyNamedList,
                            jsonifyData=TRUE,
                            alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'findProjects', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' orgFindApps API wrapper
##'
##' This function makes an API call to the \code{/org-xxxx/findApps} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Organizations#API-method\%3A-\%2Forg-xxxx\%2FfindApps}
orgFindApps <- function(objectID,
                        inputParams=emptyNamedList,
                        jsonifyData=TRUE,
                        alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'findApps', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' orgInvite API wrapper
##'
##' This function makes an API call to the \code{/org-xxxx/invite} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Organizations#API-method\%3A-\%2Forg-xxxx\%2Finvite}
orgInvite <- function(objectID,
                      inputParams=emptyNamedList,
                      jsonifyData=TRUE,
                      alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'invite', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' orgRemoveMember API wrapper
##'
##' This function makes an API call to the \code{/org-xxxx/removeMember} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Organizations#API-method\%3A-\%2Forg-xxxx\%2FremoveMember}
orgRemoveMember <- function(objectID,
                            inputParams=emptyNamedList,
                            jsonifyData=TRUE,
                            alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeMember', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' orgSetMemberAccess API wrapper
##'
##' This function makes an API call to the \code{/org-xxxx/setMemberAccess} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Organizations#API-method\%3A-\%2Forg-xxxx\%2FsetMemberAccess}
orgSetMemberAccess <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setMemberAccess', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' orgUpdate API wrapper
##'
##' This function makes an API call to the \code{/org-xxxx/update} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Organizations#API-method\%3A-\%2Forg-xxxx\%2Fupdate}
orgUpdate <- function(objectID,
                      inputParams=emptyNamedList,
                      jsonifyData=TRUE,
                      alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'update', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' orgNew API wrapper
##'
##' This function makes an API call to the \code{/org/new} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Organizations#API-method\%3A-\%2Forg\%2Fnew}
orgNew <- function(inputParams=emptyNamedList,
                   jsonifyData=TRUE,
                   alwaysRetry=FALSE) {
  dxHTTPRequest('/org/new', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' projectAddTags API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/addTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Projects#API-method\%3A-\%2Fproject-xxxx\%2FaddTags}
projectAddTags <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectClone API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/clone} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Cloning#API-method\%3A-\%2Fclass-xxxx\%2Fclone}
projectClone <- function(objectID,
                         inputParams=emptyNamedList,
                         jsonifyData=TRUE,
                         alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'clone', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectDecreasePermissions API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/decreasePermissions} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Project-Permissions-and-Sharing#API-method\%3A-\%2Fproject-xxxx\%2FdecreasePermissions}
projectDecreasePermissions <- function(objectID,
                                       inputParams=emptyNamedList,
                                       jsonifyData=TRUE,
                                       alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'decreasePermissions', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectDescribe API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Projects#API-method\%3A-\%2Fproject-xxxx\%2Fdescribe}
projectDescribe <- function(objectID,
                            inputParams=emptyNamedList,
                            jsonifyData=TRUE,
                            alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectDestroy API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/destroy} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Projects#API-method\%3A-\%2Fproject-xxxx\%2Fdestroy}
projectDestroy <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'destroy', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectInvite API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/invite} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Project-Permissions-and-Sharing#API-method\%3A-\%2Fproject-xxxx\%2Finvite}
projectInvite <- function(objectID,
                          inputParams=emptyNamedList,
                          jsonifyData=TRUE,
                          alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'invite', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectLeave API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/leave} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Project-Permissions-and-Sharing#API-method\%3A-\%2Fproject-xxxx\%2Fleave}
projectLeave <- function(objectID,
                         inputParams=emptyNamedList,
                         jsonifyData=TRUE,
                         alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'leave', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectListFolder API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/listFolder} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Folders-and-Deletion#API-method\%3A-\%2Fclass-xxxx\%2FlistFolder}
projectListFolder <- function(objectID,
                              inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listFolder', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectMove API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/move} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Folders-and-Deletion#API-method\%3A-\%2Fclass-xxxx\%2Fmove}
projectMove <- function(objectID,
                        inputParams=emptyNamedList,
                        jsonifyData=TRUE,
                        alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'move', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectNewFolder API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/newFolder} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Folders-and-Deletion#API-method\%3A-\%2Fclass-xxxx\%2FnewFolder}
projectNewFolder <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'newFolder', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectRemoveFolder API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/removeFolder} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Folders-and-Deletion#API-method\%3A-\%2Fclass-xxxx\%2FremoveFolder}
projectRemoveFolder <- function(objectID,
                                inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'removeFolder', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectRemoveObjects API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/removeObjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Folders-and-Deletion#API-method\%3A-\%2Fclass-xxxx\%2FremoveObjects}
projectRemoveObjects <- function(objectID,
                                 inputParams=emptyNamedList,
                                 jsonifyData=TRUE,
                                 alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'removeObjects', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectRemoveTags API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/removeTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Projects#API-method\%3A-\%2Fproject-xxxx\%2FremoveTags}
projectRemoveTags <- function(objectID,
                              inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectRenameFolder API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/renameFolder} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Folders-and-Deletion#API-method\%3A-\%2Fclass-xxxx\%2FrenameFolder}
projectRenameFolder <- function(objectID,
                                inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'renameFolder', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectSetProperties API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/setProperties} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Projects#API-method\%3A-\%2Fproject-xxxx\%2FsetProperties}
projectSetProperties <- function(objectID,
                                 inputParams=emptyNamedList,
                                 jsonifyData=TRUE,
                                 alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setProperties', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectTransfer API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/transfer} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Project-Permissions-and-Sharing#API-method\%3A-\%2Fproject-xxxx\%2Ftransfer}
projectTransfer <- function(objectID,
                            inputParams=emptyNamedList,
                            jsonifyData=TRUE,
                            alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'transfer', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectUpdate API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/update} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Projects#API-method\%3A-\%2Fproject-xxxx\%2Fupdate}
projectUpdate <- function(objectID,
                          inputParams=emptyNamedList,
                          jsonifyData=TRUE,
                          alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'update', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectUpdateSponsorship API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/updateSponsorship} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Projects#API-method\%3A-\%2Fproject-xxxx\%2FupdateSponsorship}
projectUpdateSponsorship <- function(objectID,
                                     inputParams=emptyNamedList,
                                     jsonifyData=TRUE,
                                     alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'updateSponsorship', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectNew API wrapper
##'
##' This function makes an API call to the \code{/project/new} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Projects#API-method\%3A-\%2Fproject\%2Fnew}
projectNew <- function(inputParams=emptyNamedList,
                       jsonifyData=TRUE,
                       alwaysRetry=FALSE) {
  dxHTTPRequest('/project/new', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' recordAddTags API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/addTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Tags#API-method\%3A-\%2Fclass-xxxx\%2FaddTags}
recordAddTags <- function(objectID,
                          inputParams=emptyNamedList,
                          jsonifyData=TRUE,
                          alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordAddTypes API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/addTypes} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Types#API-method\%3A-\%2Fclass-xxxx\%2FaddTypes}
recordAddTypes <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTypes', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordClose API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/close} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Data-Object-Lifecycle#API-method\%3A-\%2Fclass-xxxx\%2Fclose}
recordClose <- function(objectID,
                        inputParams=emptyNamedList,
                        jsonifyData=TRUE,
                        alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'close', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordDescribe API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Records#API-method\%3A-\%2Frecord-xxxx\%2Fdescribe}
recordDescribe <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordGetDetails API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/getDetails} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Details-and-Links#API-method\%3A-\%2Fclass-xxxx\%2FgetDetails}
recordGetDetails <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'getDetails', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordListProjects API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/listProjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Cloning#API-method\%3A-\%2Fclass-xxxx\%2FlistProjects}
recordListProjects <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listProjects', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordRemoveTags API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/removeTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Tags#API-method\%3A-\%2Fclass-xxxx\%2FremoveTags}
recordRemoveTags <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordRemoveTypes API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/removeTypes} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Types#API-method\%3A-\%2Fclass-xxxx\%2FremoveTypes}
recordRemoveTypes <- function(objectID,
                              inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTypes', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordRename API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/rename} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Name#API-method\%3A-\%2Fclass-xxxx\%2Frename}
recordRename <- function(objectID,
                         inputParams=emptyNamedList,
                         jsonifyData=TRUE,
                         alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'rename', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordSetDetails API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/setDetails} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Details-and-Links#API-method\%3A-\%2Fclass-xxxx\%2FsetDetails}
recordSetDetails <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setDetails', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordSetProperties API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/setProperties} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Properties#API-method\%3A-\%2Fclass-xxxx\%2FsetProperties}
recordSetProperties <- function(objectID,
                                inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setProperties', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordSetVisibility API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/setVisibility} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Visibility#API-method\%3A-\%2Fclass-xxxx\%2FsetVisibility}
recordSetVisibility <- function(objectID,
                                inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setVisibility', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordNew API wrapper
##'
##' This function makes an API call to the \code{/record/new} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Records#API-method\%3A-\%2Frecord\%2Fnew}
recordNew <- function(inputParams=emptyNamedList,
                      jsonifyData=TRUE,
                      alwaysRetry=FALSE) {
  dxHTTPRequest('/record/new', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemDescribeDataObjects API wrapper
##'
##' This function makes an API call to the \code{/system/describeDataObjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/System-Methods#API-method:-/system/describeDataObjects}
systemDescribeDataObjects <- function(inputParams=emptyNamedList,
                                      jsonifyData=TRUE,
                                      alwaysRetry=TRUE) {
  dxHTTPRequest('/system/describeDataObjects', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemDescribeExecutions API wrapper
##'
##' This function makes an API call to the \code{/system/describeExecutions} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/System-Methods#API-method:-/system/describeExecutions}
systemDescribeExecutions <- function(inputParams=emptyNamedList,
                                     jsonifyData=TRUE,
                                     alwaysRetry=TRUE) {
  dxHTTPRequest('/system/describeExecutions', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemDescribeProjects API wrapper
##'
##' This function makes an API call to the \code{/system/describeProjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/System-Methods#API-method:-/system/describeProjects}
systemDescribeProjects <- function(inputParams=emptyNamedList,
                                   jsonifyData=TRUE,
                                   alwaysRetry=TRUE) {
  dxHTTPRequest('/system/describeProjects', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindAffiliates API wrapper
##'
##' This function makes an API call to the \code{/system/findAffiliates} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
systemFindAffiliates <- function(inputParams=emptyNamedList,
                                 jsonifyData=TRUE,
                                 alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findAffiliates', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindApps API wrapper
##'
##' This function makes an API call to the \code{/system/findApps} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Search#API-method\%3A-\%2Fsystem\%2FfindApps}
systemFindApps <- function(inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findApps', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindDataObjects API wrapper
##'
##' This function makes an API call to the \code{/system/findDataObjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Search#API-method\%3A-\%2Fsystem\%2FfindDataObjects}
systemFindDataObjects <- function(inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findDataObjects', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindGlobalWorkflows API wrapper
##'
##' This function makes an API call to the \code{/system/findGlobalWorkflows} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
systemFindGlobalWorkflows <- function(inputParams=emptyNamedList,
                                      jsonifyData=TRUE,
                                      alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findGlobalWorkflows', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemResolveDataObjects API wrapper
##'
##' This function makes an API call to the \code{/system/resolveDataObjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/System-Methods#API-method:-/system/resolveDataObjects}
systemResolveDataObjects <- function(inputParams=emptyNamedList,
                                     jsonifyData=TRUE,
                                     alwaysRetry=TRUE) {
  dxHTTPRequest('/system/resolveDataObjects', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindExecutions API wrapper
##'
##' This function makes an API call to the \code{/system/findExecutions} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Search#API-method\%3A-\%2Fsystem\%2FfindExecutions}
systemFindExecutions <- function(inputParams=emptyNamedList,
                                 jsonifyData=TRUE,
                                 alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findExecutions', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindAnalyses API wrapper
##'
##' This function makes an API call to the \code{/system/findAnalyses} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Search#API-method\%3A-\%2Fsystem\%2FfindAnalyses}
systemFindAnalyses <- function(inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findAnalyses', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindDatabases API wrapper
##'
##' This function makes an API call to the \code{/system/findDatabases} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Search#API-method\%3A-\%2Fsystem\%2FfindDatabases}
systemFindDatabases <- function(inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findDatabases', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindJobs API wrapper
##'
##' This function makes an API call to the \code{/system/findJobs} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Search#API-method\%3A-\%2Fsystem\%2FfindJobs}
systemFindJobs <- function(inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findJobs', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindProjects API wrapper
##'
##' This function makes an API call to the \code{/system/findProjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Search#API-method\%3A-\%2Fsystem\%2FfindProjects}
systemFindProjects <- function(inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findProjects', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindUsers API wrapper
##'
##' This function makes an API call to the \code{/system/findUsers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Search#API-method\%3A-\%2Fsystem\%2FfindUsers}
systemFindUsers <- function(inputParams=emptyNamedList,
                            jsonifyData=TRUE,
                            alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findUsers', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindProjectMembers API wrapper
##'
##' This function makes an API call to the \code{/system/findProjectMembers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Search#API-method:-/system/findProjectMembers}
systemFindProjectMembers <- function(inputParams=emptyNamedList,
                                     jsonifyData=TRUE,
                                     alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findProjectMembers', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindOrgs API wrapper
##'
##' This function makes an API call to the \code{/system/findOrgs} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Search#API-method:-/system/findOrgs}
systemFindOrgs <- function(inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findOrgs', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemGenerateBatchInputs API wrapper
##'
##' This function makes an API call to the \code{/system/generateBatchInputs} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Search#API-method:-/system/generateBatchInputs}
systemGenerateBatchInputs <- function(inputParams=emptyNamedList,
                                      jsonifyData=TRUE,
                                      alwaysRetry=TRUE) {
  dxHTTPRequest('/system/generateBatchInputs', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemGlobalSearch API wrapper
##'
##' This function makes an API call to the \code{/system/globalSearch} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Search#API-method:-/system/globalSearch}
systemGlobalSearch <- function(inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  dxHTTPRequest('/system/globalSearch', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemGreet API wrapper
##'
##' This function makes an API call to the \code{/system/greet} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
systemGreet <- function(inputParams=emptyNamedList,
                        jsonifyData=TRUE,
                        alwaysRetry=TRUE) {
  dxHTTPRequest('/system/greet', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemHeaders API wrapper
##'
##' This function makes an API call to the \code{/system/headers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
systemHeaders <- function(inputParams=emptyNamedList,
                          jsonifyData=TRUE,
                          alwaysRetry=TRUE) {
  dxHTTPRequest('/system/headers', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemShortenURL API wrapper
##'
##' This function makes an API call to the \code{/system/shortenURL} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
systemShortenURL <- function(inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  dxHTTPRequest('/system/shortenURL', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemWhoami API wrapper
##'
##' This function makes an API call to the \code{/system/whoami} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
systemWhoami <- function(inputParams=emptyNamedList,
                         jsonifyData=TRUE,
                         alwaysRetry=TRUE) {
  dxHTTPRequest('/system/whoami', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' userDescribe API wrapper
##'
##' This function makes an API call to the \code{/user-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Users#API-method\%3A-\%2Fuser-xxxx\%2Fdescribe}
userDescribe <- function(objectID,
                         inputParams=emptyNamedList,
                         jsonifyData=TRUE,
                         alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' userUpdate API wrapper
##'
##' This function makes an API call to the \code{/user-xxxx/update} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Users#API-method\%3A-\%2Fuser-xxxx\%2Fupdate}
userUpdate <- function(objectID,
                       inputParams=emptyNamedList,
                       jsonifyData=TRUE,
                       alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'update', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowAddStage API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/addStage} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Workflows-and-Analyses#API-method\%3A-\%2Fworkflow-xxxx\%2FaddStage}
workflowAddStage <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addStage', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowAddTags API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/addTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Tags#API-method\%3A-\%2Fclass-xxxx\%2FaddTags}
workflowAddTags <- function(objectID,
                            inputParams=emptyNamedList,
                            jsonifyData=TRUE,
                            alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowAddTypes API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/addTypes} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Types#API-method\%3A-\%2Fclass-xxxx\%2FaddTypes}
workflowAddTypes <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTypes', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowClose API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/close} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Data-Object-Lifecycle#API-method\%3A-\%2Fclass-xxxx\%2Fclose}
workflowClose <- function(objectID,
                          inputParams=emptyNamedList,
                          jsonifyData=TRUE,
                          alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'close', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowDescribe API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Workflows-and-Analyses#API-method\%3A-\%2Fworkflow-xxxx\%2Fdescribe}
workflowDescribe <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowDryRun API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/dryRun} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Workflows-and-Analyses#API-method\%3A-\%2Fworkflow-xxxx\%2FdryRun}
workflowDryRun <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'dryRun', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowGetDetails API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/getDetails} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Details-and-Links#API-method\%3A-\%2Fclass-xxxx\%2FgetDetails}
workflowGetDetails <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'getDetails', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowIsStageCompatible API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/isStageCompatible} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Workflows-and-Analyses#API-method\%3A-\%2Fworkflow-xxxx\%2FisStageCompatible}
workflowIsStageCompatible <- function(objectID,
                                      inputParams=emptyNamedList,
                                      jsonifyData=TRUE,
                                      alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'isStageCompatible', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowListProjects API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/listProjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Cloning#API-method\%3A-\%2Fclass-xxxx\%2FlistProjects}
workflowListProjects <- function(objectID,
                                 inputParams=emptyNamedList,
                                 jsonifyData=TRUE,
                                 alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listProjects', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowMoveStage API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/moveStage} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Workflows-and-Analyses#API-method\%3A-\%2Fworkflow-xxxx\%2FmoveStage}
workflowMoveStage <- function(objectID,
                              inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'moveStage', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowOverwrite API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/overwrite} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Workflows-and-Analyses#API-method\%3A-\%2Fworkflow-xxxx\%2Foverwrite}
workflowOverwrite <- function(objectID,
                              inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'overwrite', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowRemoveStage API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/removeStage} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Workflows-and-Analyses#API-method\%3A-\%2Fworkflow-xxxx\%2FremoveStage}
workflowRemoveStage <- function(objectID,
                                inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeStage', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowRemoveTags API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/removeTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Tags#API-method\%3A-\%2Fclass-xxxx\%2FremoveTags}
workflowRemoveTags <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowRemoveTypes API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/removeTypes} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Types#API-method\%3A-\%2Fclass-xxxx\%2FremoveTypes}
workflowRemoveTypes <- function(objectID,
                                inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTypes', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowRename API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/rename} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Name#API-method\%3A-\%2Fclass-xxxx\%2Frename}
workflowRename <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'rename', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowRun API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/run} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Workflows-and-Analyses#API-method\%3A-\%2Fworkflow-xxxx\%2Frun}
workflowRun <- function(objectID,
                        inputParams=emptyNamedList,
                        jsonifyData=TRUE,
                        alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'run', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowValidateBatch API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/validateBatch} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Workflows-and-Analyses#API-method\%3A-\%2Fworkflow-xxxx\%2FvalidateBatch}
workflowValidateBatch <- function(objectID,
                                  inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'validateBatch', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowSetDetails API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/setDetails} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Details-and-Links#API-method\%3A-\%2Fclass-xxxx\%2FsetDetails}
workflowSetDetails <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setDetails', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowSetProperties API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/setProperties} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Properties#API-method\%3A-\%2Fclass-xxxx\%2FsetProperties}
workflowSetProperties <- function(objectID,
                                  inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setProperties', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowSetStageInputs API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/setStageInputs} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Workflows-and-Analyses#API-method\%3A-\%2Fworkflow-xxxx\%2FsetStageInputs}
workflowSetStageInputs <- function(objectID,
                                   inputParams=emptyNamedList,
                                   jsonifyData=TRUE,
                                   alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setStageInputs', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowSetVisibility API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/setVisibility} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Visibility#API-method\%3A-\%2Fclass-xxxx\%2FsetVisibility}
workflowSetVisibility <- function(objectID,
                                  inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setVisibility', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowUpdate API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/update} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Workflows-and-Analyses#API-method\%3A-\%2Fworkflow-xxxx\%2Fupdate}
workflowUpdate <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'update', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowUpdateStageExecutable API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/updateStageExecutable} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Workflows-and-Analyses#API-method\%3A-\%2Fworkflow-xxxx\%2FupdateStageExecutable}
workflowUpdateStageExecutable <- function(objectID,
                                          inputParams=emptyNamedList,
                                          jsonifyData=TRUE,
                                          alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'updateStageExecutable', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowNew API wrapper
##'
##' This function makes an API call to the \code{/workflow/new} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://wiki.dnanexus.com/API-Specification-v1.0.0/Workflows-and-Analyses#API-method\%3A-\%2Fworkflow\%2Fnew}
workflowNew <- function(inputParams=emptyNamedList,
                        jsonifyData=TRUE,
                        alwaysRetry=FALSE) {
  dxHTTPRequest('/workflow/new', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}
